
# -* coding: iso-8859-1 -*-
"""
**********************************************************************
File Name:            TWITTER.py
Dev:                  Daniele De Santis
Email:                desantis@areasx.com
Web:                  http://www.areasx.com

Versione:             0.0
Data:                 16/09/11
Note Hardware:        Telit PY
Note Software: 
**********************************************************************
"""
import MDM
import GPIO
import MOD
import sys

DEBUG_ON =1
DEBUG_AT =1

TwitterStatus    = "Un TWITTER via GPRS dal mio Telit GM862"
TwitterToken     = "318938137-xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"

APN = "ibox.tim.it"
UID = ""
PWD = ""
TIMEOUT_CMD       = 20
TIMEOUT_CONNECT   = 500 
REG_TIMEOUT       = 60

def InitGPIO():
  #Uscite
  r=GPIO.setIOdir(2,0,1) #setto il port 2 come output e ha come valore di default 0
  r=GPIO.setIOdir(6,0,1) #setto il port 6 come output e ha come valore di default 0
  r=GPIO.setIOdir(7,0,1) #setto il port 7 come output e ha come valore di default 0
  #Ingressi
  r=GPIO.setIOdir(1,0,0) #setto il port 1 come input
  r=GPIO.setIOdir(8,0,0) #setto il port 8 come input

def SEND_CMD(CMD_TX, CMD_TOUT=10):
  RX_BUF = MDM.send(CMD_TX,0)
  TIMEOUT = MOD.secCounter()
  while(1):
    RX_BUF = MDM.receive(CMD_TOUT)
    if(len(RX_BUF)>0): return RX_BUF
    if (MOD.secCounter()>TIMEOUT+CMD_TOUT):  break #Timeout 10 sec
  return ""

#Inizializzazione del modem
def InitModem():
  TX_BUF ="ATH\r" #Invio comando AT
  if(DEBUG_AT): print TX_BUF
  RX_BUF = SEND_CMD(TX_BUF,TIMEOUT_CMD)
  if(DEBUG_AT): print RX_BUF
  if(RX_BUF.find('OK') == -1): return -1
  
  TX_BUF ="AT\r" #Invio comando AT
  if(DEBUG_AT): print TX_BUF
  RX_BUF = SEND_CMD(TX_BUF,TIMEOUT_CMD)
  if(DEBUG_AT): print RX_BUF
  if(RX_BUF.find('OK') == -1): return -1
  
  TX_BUF ="AT#SELINT=2\r" #Passa a AT#SELINT = 2
  if(DEBUG_AT): print TX_BUF
  RX_BUF = SEND_CMD(TX_BUF,TIMEOUT_CMD)
  if(DEBUG_AT): print RX_BUF
  if(RX_BUF.find('OK') == -1): return -5
    
  #Imposta il centro servizi
  """
  TX_BUF="AT+CSCA=\"%s\",145\r" % (SERVICE_CENTER)
  if(DEBUG_AT): print TX_BUF
  RX_BUF = SEND_CMD(TX_BUF,TIMEOUT_CMD * 5)
  if(DEBUG_AT): print RX_BUF
  if(RX_BUF.find('OK') == -1): 
    return -3
  else:
    return 1
  """
  
  return 1
  
#Verifica a registrazione del modem alla rete GPRS
def CheckModemReg():
  TX_BUF="AT+CGREG?\r"
  RX_BUF = SEND_CMD(TX_BUF, TIMEOUT_CMD * 20)
  if (RX_BUF.find ('+CGREG: 0,1') != -1): #Registrato alla rete
    return 1
  elif (RX_BUF.find ('+CGREG: 0,5') != -1): #registrato in roaming
    return 2
  return 0

#Avvia la connessione GPRS
#Ritorna: 0 Connessione Fallita
#         IP se la connessione riesce
def InitGprsConnection(APN, UID, PWD, TIMEOUT_CMD):
  #Termino eventuale precedente connessione
  TX_BUF="AT#GPRS=0\r"
  RX_BUF = SEND_CMD(TX_BUF, TIMEOUT_CMD * 5)
  if(RX_BUF.find('OK') == -1): return 0
  TX_BUF="AT+CGDCONT=1,\"IP\",\"%s\",\"0.0.0.0\",0,0\r" % APN
  if(DEBUG_AT): print TX_BUF
  RX_BUF = SEND_CMD(TX_BUF, TIMEOUT_CMD * 5)
  if(DEBUG_AT): print RX_BUF
  if(RX_BUF.find('OK') == -1): return 0
  TX_BUF="AT#USERID=\"%s\"\r" % UID
  if(DEBUG_AT): print TX_BUF
  RX_BUF = SEND_CMD(TX_BUF, TIMEOUT_CMD * 5)
  if(DEBUG_AT): print RX_BUF
  if(RX_BUF.find('OK') == -1): return 0
  TX_BUF="AT#PASSW=\"%s\"\r" % PWD
  if(DEBUG_AT): print TX_BUF
  RX_BUF = SEND_CMD(TX_BUF, TIMEOUT_CMD * 5)
  if(DEBUG_AT): print RX_BUF
  if(RX_BUF.find('OK') == -1): return 0
  TX_BUF = "AT#GPRS=1\r"
  if(DEBUG_AT): print TX_BUF
  RX_BUF = SEND_CMD(TX_BUF, TIMEOUT_CONNECT * 5)
  if(DEBUG_AT): print RX_BUF
  if(RX_BUF.find('OK') == -1): 
    return 0
  else: #estraggo l'IP assegnato alla connessione
    RX_BUF = RX_BUF.split("\r\n") #taglia \r\n
    if(len(RX_BUF)>2):
      RX_BUF=RX_BUF[1].split(" ")
      if(len(RX_BUF)>0):
        return RX_BUF[1]
  return 0

#Verifica lo stato della connessione GPRS
def CheckGprsConnection():
  TX_BUF="AT#GPRS?\r" #Ritorna lo stato della connessione GPRS
  if(DEBUG_ON): print TX_BUF
  RX_BUF = SEND_CMD(TX_BUF, TIMEOUT_CONNECT * 5)
  if(DEBUG_ON): print RX_BUF
  if(RX_BUF.find('OK') != -1):
    if(RX_BUF.find('#GPRS: 1') != -1):
      if(DEBUG_ON): print "Contesto GPRS attivo"
      return 1
    elif(RX_BUF.find('#GPRS: 0') != -1):
      if(DEBUG_ON): print "Contesto GPRS NON attivo"
      return 0
  return -1

#Termina connessione GPRS
def ShutdownGprsConnection():
  if(DEBUG_ON): print "disattivo il contesto GPRS "
  for i in range(0, 5):
    if(CheckGprsConnection()==0): 
      return 1
    TX_BUF="AT#GPRS=0\r"
    RX_BUF = SEND_CMD(TX_BUF, TIMEOUT_CONNECT * 50)
    if(DEBUG_ON): 
      print "Shutdown Gprs tentativo %d di 5" % i
      print RX_BUF
    #if(RX_BUF.find('OK')==-1): return -1
    MOD.sleep(10)
  return 0
  
#Passa alla modalita' AT
def SwitchATmode():
  MOD.sleep(20)
  RX_BUF = MDM.send('+++',0)
  MOD.sleep(20)
  RX_BUF = MDM.receive(TIMEOUT_CMD * 2)
  if(RX_BUF.find('OK') != -1):
    if(DEBUG_ON): print "Sono in modalit AT"
    return 1
  return 0


def Twitter(TwitterStatus, TwitterToken):
  TWITTER_APP_SRV  = "www.desantix.it"
  TWITTER_APP_PATH = "/twitter/twitthttp/"
  
  TX_BUF = "AT#SD=2, 0, %d, \"%s\"\r" % (80, TWITTER_APP_SRV)
  RX_BUF = SEND_CMD(TX_BUF, 90)
  if(RX_BUF.find("CONNECT") == -1):
    if(DEBUG_ON): print "ERRORE Connessione con %s fallita" % TWITTER_APP_SRV
    return (10)
    
  if(DEBUG_ON): print "Connessione con %s " % TWITTER_APP_SRV
  POST_BUF = "POST %s HTTP/1.1\r\n" % TWITTER_APP_PATH
  POST_BUF = POST_BUF + "Host: %s\r\nUser-Agent: Mozilla/4.0\r\n" % TWITTER_APP_SRV
  RX_BUF = MDM.send(POST_BUF,0)
  POST_QUERY = "status=%s&token=%s" % (TwitterStatus, TwitterToken)
  POST_BUF = "Content-Length: %d\r\nContent-Type: application/x-www-form-urlencoded\r\n\r\n" % len(POST_QUERY)
  RX_BUF = MDM.send(POST_BUF,0) #trasmetto
  POST_BUF = "%s\r\n" % POST_QUERY
  RX_BUF = MDM.send(POST_BUF,0)
  
  #Attendo una risposta dal WEB SERVER
  RX_BUFF=""
  TIMEOUT = MOD.secCounter()
  while(1):
    RX_BUFF = RX_BUFF + MDM.receive(10)
    if(RX_BUFF.find("NO CARRIER") != -1): break    #terminata laconnessione correttamente
    if (RX_BUFF.find("ERROR") != -1):     break    #Ritornato errore
    if (MOD.secCounter()>TIMEOUT+30):     #Chiusura per Timeout
      DEBUG_TXT = "ATTENZIONE Nessuna risposta dal server %s" % TWITTER_APP_SRV
      if(DEBUG_ON): print DEBUG_TXT
      return (10)
  #Termino la connessione
  TX_BUF="AT#SH=2\r"
  RX_BUF = SEND_CMD(TX_BUF, TIMEOUT_CMD * 5) #End socket
  #ANALIZZO RISPOSTA
  RX_BUF=RX_BUFF.find("\r\n\r\n")
  if(RX_BUF>0 and RX_BUF!=-1):
    RX_BUFF=RX_BUFF[(RX_BUF+2):]    #Estrae il body della risposta al GET
    if(DEBUG_ON): print "RITORNO HTTP %s" % RX_BUFF
    if(RX_BUFF.find("TX OK") != -1 ):   return (0)
    if(RX_BUFF.find("ERROR 1") != -1 ): return (1)
    if(RX_BUFF.find("ERROR 2") != -1 ): return (2)
    if(RX_BUFF.find("ERROR 3") != -1 ): return (3)
    if(RX_BUFF.find("ERROR 4") != -1 ): return (4)
  return (10)

#MAIN LOOP
state=0
while(1):
  #######################################
  ##STEP 1 Inizializzazione del modem
  #######################################
  if (state==0):
    DEBUG_TXT = "Inizializzazione del modem" 
    if(DEBUG_ON): print DEBUG_TXT
    for i in range(0, 10):
      ERR_CODE = InitModem()
      if(ERR_CODE>0):
        break
      else:
        MOD.sleep(50)
    
    if (ERR_CODE>0): 
      state=state + 1
      DEBUG_TXT = "Modem inizializzato correttamente" 
      if(DEBUG_ON): print DEBUG_TXT
    else:
      DEBUG_TXT = "ERRORE Impossibile inizializzare il modem. CODE %d" % ERR_CODE 
      if(DEBUG_ON): print DEBUG_TXT
      sys.exit(0) #Impossibile inizializzare il modem esco
      
  #######################################
  #STEP 1 Attende la registrazione del modem alla rete GSM
  #######################################
  elif (state==1):
    while(1): #Attendo la registrazione del modem
      if(CheckModemReg()>0): break;
      MOD.sleep(50)
    DEBUG_TXT = "Registrazione del modem riuscita" 
    if(DEBUG_ON): print DEBUG_TXT
    DEBUG_TXT = "Sistema pronto!" 
    if(DEBUG_ON): print DEBUG_TXT
    TimeoutReg = MOD.secCounter()
    state=state+1
    
  #######################################
  #STEP 2 Attende Pressione Tasto
  #######################################
  elif(state==2):
    if(MOD.secCounter() > (TimeoutReg+REG_TIMEOUT)): state=1 #Verifica registrazione
    if(GPIO.getIOvalue(8)==0):
      state=state+1
      DEBUG_TXT = "Pressione Tasto ...Twitto :=)"
      if(DEBUG_ON): print DEBUG_TXT
      s=GPIO.setIOvalue(2,1)
      
  #######################################
  #STEP 3 Avvio connessione GPRS
  #######################################
  elif(state==3):
    if(DEBUG_ON): 
      DEBUG_TXT = "Avvio connessione GPRS APN: " + APN
      if(DEBUG_ON): print DEBUG_TXT
    if not(CheckGprsConnection()):
      ret=InitGprsConnection(APN, UID, PWD, 5)
      if(ret==0):
        DEBUG_TXT = "ERRORE Impossibile attivare contesto GPRS con l'APN: " + APN
        if(DEBUG_ON): print DEBUG_TXT
        state=5
        continue
    CONN_IP = ret
    DEBUG_TXT = "Contesto GPRS all'APN: " + APN + " attivo. IP: " + ret
    if(DEBUG_ON): print DEBUG_TXT
    state=state+1

  #######################################
  #STEP 7 trasmetto POST
  #######################################
  elif(state==4):
    DEBUG_TXT = "Trasmetto il Twitter"
    if(DEBUG_ON): print DEBUG_TXT

    ret=Twitter(TwitterStatus, TwitterToken)
    if(ret==0): 
      print "Il modem Telit ha twittato ;)"
    else:
      print "ERRORE - Twitter fallito ! CODE %d" % ret
    state=state+1
    
  #######################################
  #STEP 5 Termino la connessione GPRS
  #######################################
  elif(state==5):
    ShutdownGprsConnection()
    s=GPIO.setIOvalue(2,0)
    DEBUG_TXT = "Contesto GPRS disattivato"
    if(DEBUG_ON): print DEBUG_TXT
    state=1 #passo al controllo di registrazione.
